<div class="example-container mat-elevation-z8">
  <table mat-table [dataSource]="dataSource">
    <!-- * Filter * -->
    <ng-container matColumnDef="filter">
      <th mat-header-cell *matHeaderCellDef colspan="5">
        <mat-form-field appearance="standard">
          <mat-label>Filter</mat-label>
          <input
            matInput
            (keyup)="applyFilter($event)"
            placeholder="Ex. Coffee, Bread, Juice"
            #input
          />
        </mat-form-field>
      </th>
    </ng-container>

    <!-- Position Column -->
    <ng-container matColumnDef="position">
      <th mat-header-cell *matHeaderCellDef>No.</th>
      <td mat-cell *matCellDef="let item">
        {{ dataSource.data.indexOf(item) + 1 }}
      </td>
    </ng-container>

    <!-- Name Column -->
    <ng-container matColumnDef="name">
      <th mat-header-cell *matHeaderCellDef>Name</th>
      <td mat-cell *matCellDef="let item">
        <ng-container *ngIf="isEdit(editMode, item); else elseTemplate">
          <mat-form-field appearance="outline">
            <input matInput type="text" [formControl]="name" />
          </mat-form-field>
        </ng-container>
        <ng-template #elseTemplate> {{ item?.name }} </ng-template>
      </td>
    </ng-container>

    <!-- Cost Column -->
    <ng-container matColumnDef="cost">
      <th mat-header-cell *matHeaderCellDef>Cost ($)</th>
      <td mat-cell *matCellDef="let item">
        <ng-container *ngIf="isEdit(editMode, item); else elseTemplate">
          <mat-form-field appearance="outline">
            <input matInput type="number" [formControl]="cost"
          /></mat-form-field>
        </ng-container>
        <ng-template #elseTemplate> {{ item?.cost | currency }} </ng-template>
      </td>
    </ng-container>
    <!-- Tax Column -->
    <ng-container matColumnDef="tax">
      <th mat-header-cell *matHeaderCellDef>Tax (%)</th>
      <td mat-cell *matCellDef="let item">
        <ng-container *ngIf="isEdit(editMode, item); else elseTemplate">
          <mat-form-field appearance="outline">
            <input matInput type="number" [formControl]="tax"
          /></mat-form-field>
        </ng-container>
        <ng-template #elseTemplate> {{ item?.tax }} % </ng-template>
      </td>
    </ng-container>
    <!-- Action Column -->
    <ng-container matColumnDef="action">
      <th mat-header-cell *matHeaderCellDef>Actions</th>
      <td mat-cell *matCellDef="let item">
        <ng-container *ngIf="isEdit(editMode, item); else elseTemplate">
          <button
            mat-icon-button
            color="primary"
            [disabled]="!form.valid"
            (click)="
              onEditItem(item); toggleEdit(dataSource.data.indexOf(item), item)
            "
          >
            <mat-icon>check</mat-icon>
          </button>

          <button
            mat-icon-button
            color="primary"
            (click)="toggleEdit(dataSource.data.indexOf(item), item)"
          >
            <mat-icon>cancel</mat-icon>
          </button>
        </ng-container>
        <ng-template #elseTemplate>
          <button
            mat-icon-button
            color="primary"
            *ngIf="displayedButtons.includes('edit')"
            (click)="toggleEdit(dataSource.data.indexOf(item), item)"
          >
            <mat-icon>edit</mat-icon>
          </button>
          <button
            mat-icon-button
            color="warn"
            *ngIf="displayedButtons.includes('delete')"
            (click)="onDeleteItem(item)"
          >
            <mat-icon>delete</mat-icon>
          </button>

          <button
            mat-icon-button
            color="warn"
            *ngIf="displayedButtons.includes('add_to_sc')"
            (click)="onAddToShoppingCart(item)"
          >
            <mat-icon>add_shopping_cart</mat-icon>
          </button>

          <button
            mat-icon-button
            color="warn"
            *ngIf="displayedButtons.includes('remove_from_sc')"
            (click)="onRemoveFromShoppingCart(item)"
          >
            <mat-icon>remove_shopping_cart</mat-icon>
          </button>
        </ng-template>
      </td>
    </ng-container>

    <!-- * Paginator * -->
    <ng-container matColumnDef="paginator">
      <td mat-footer-cell *matFooterCellDef colspan="5">
        <mat-paginator [pageSizeOptions]="[10, 25, 100]"></mat-paginator>
      </td>
    </ng-container>

    <!-- **Headers** -->
    <tr mat-header-row *matHeaderRowDef="['filter']"></tr>
    <tr mat-header-row *matHeaderRowDef="displayedColumns; sticky: true"></tr>

    <!-- **Rows** -->
    <tr mat-row *matRowDef="let row; columns: displayedColumns"></tr>
    <!-- Row shown when there is no matching data. -->
    <tr class="mat-row" *matNoDataRow>
      <td class="mat-cell" colspan="5">No data matching the filter</td>
    </tr>

    <!-- **Footers** -->
    <tr mat-footer-row *matFooterRowDef="['paginator']; sticky: true"></tr>
  </table>
</div>
